package de.dkn.asteroids;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;

/**
 * <p>
 * Wiederholt den Asteroid-Vorrunden-MAME starten und den DknAsteroidsPlayer dagegen laufen lassen.
 * </p>
 * <p>
 * HINWEIS: Die Domain de.dkn gehrt nicht mir, aber ich benutze das Krzel dkn schon sehr lange und
 * meine, bzw. unsere Domain de.familie-damken ist nicht Java-fhig und damit ist de.dkn aus meiner
 * Sicht genauso geeignet wie jede abweichende Schreibweise von de.familie-damken.
 * </p>
 * <p>
 * (c) 2008, by Uwe Damken ... basierend auf einem Framework von Rammi (rammi@caff.de)
 * </p>
 */
public class DknBatchMultiRunner {

	/**
	 * Main eben.
	 */
	public static void main(String[] args) {
		try {
			DknStatistics statistics = DknStatistics.getInstance();
			for (int i = 0; i < 100; i++) {
				System.out.println(String.format("Running %d started ...", i));
				Process mame = Runtime.getRuntime().exec(
						"C:/Programme/mame/rec/mameaster.exe asteroid -window -skip_gameinfo",
						null, new File("C:/Programme/mame/rec"));
				Thread.sleep(2000);
				Process player = Runtime
						.getRuntime()
						.exec(
								"java -mx1000m -Xincgc -jar C:/Programme/mame/rec/DknAsteroidsPlayer.jar -p DknPlayerStarter");
				BufferedInputStream buffer = new BufferedInputStream(player.getInputStream());
				BufferedReader commandResult = new BufferedReader(new InputStreamReader(buffer));

				String s = null;
				while (true) {
					s = commandResult.readLine();
					System.out.println("Output: " + s);
					System.out.flush();
					if (s.startsWith("Statistics: ")) {
						statistics.addValue(Integer.parseInt(s.split("=")[3]));
					}
					if (s.startsWith("New server state: GAME_OVER")) {
						break;
					}
				}
				Thread.sleep(2000);
				player.destroy();
				player.waitFor();
				mame.destroy();
				mame.waitFor();
				System.out.println(String.format("Running %d ... done", i));
			}
			System.out.println("Overall " + statistics.toString());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
